;Ŀ
;                                                                  
;                      ۰                                           
;                                                                     
;                                                           
;                      ۰     ۰   ۰                         
;                                                          
;                                ۰                          
;                            ۰                              
;                                                         
;                                                                         
;                         Version      0.9 eta                         
;                                                                       
;                                                                           
;                            Copyright (C) 1997                             
;                               Ben Sferrazza                               
;                          bens@nj.semi.harris.com                          
;                                                                           
;                        RIGEL.H Header File ۲                       
;

;Ŀ
; #DEFINES                                                                  
;
#DEFINE ROM_CALL(addr)                  call addr
#DEFINE ROM_CALL_C(addr)                call c, addr
#DEFINE ROM_CALL_NC(addr)               call nc, addr
#DEFINE ROM_CALL_Z(addr)                call z, addr
#DEFINE ROM_CALL_NZ(addr)               call nz, addr
#DEFINE LIB_CALL_(addr)                 call addr
#DEFINE LIB_CALL_C(addr)                call c, addr
#DEFINE LIB_CALL_NC(addr)               call nc, addr
#DEFINE LIB_CALL_Z(addr)                call z, addr
#DEFINE LIB_CALL_NZ(addr)               call nz, addr
#DEFINE CALL_(addr)                     call addr
#DEFINE CALL_C(addr)                    call c, addr
#DEFINE CALL_NC(addr)                   call nc, addr
#DEFINE CALL_Z(addr)                    call z, addr
#DEFINE CALL_NZ(addr)                   call nz, addr
#DEFINE JUMP_(addr)                     jp addr
#DEFINE JUMP_C(addr)                    jp c, addr
#DEFINE JUMP_NC(addr)                   jp nc, addr
#DEFINE JUMP_Z(addr)                    jp z, addr
#DEFINE JUMP_NZ(addr)                   jp nz, addr
;Ŀ
; Rigel Locations                                                           
;
PROGRAM_ADDR    = $8C3C  ; Address of the currently run program
ROM_VER         = $8C3E  ; ROM version byte
RIGEL_VER       = $8C3F  ; Rigel version byte (BCD), 1st digit is major num,
                         ; second digit is the minor num (e.g. $12 = v1.2)
RIGEL_BITS      = $8C40  ; bit 0 = no longer used - ZShell used it to
                         ;         recalculate the checksum byte
                         ; bit 1 = no longer used - ZShell used it to exit
                         ;         to TI-OS upon program completion
                         ; bit 2 = reserved
                         ; bit 3 = reserved
                         ; bit 4 = reserved
                         ; bit 5 = reserved
                         ; bit 6 = reserved
                         ; bit 7 = reserved
PROG_START      = $9296  ; The starting address of the currently executed
                         ; string
;Ŀ
; ROM Routine Locations                                                     
;
;Page 0
;
LD_HL_MHL       = $0033  ; HL=(HL), A=L
CP_HL_DE        = $008E  ; CP HL,DE (modifies flags only)
UNPACK_HL       = $009A  ; unpacks one digit of HL into %A
STORE_KEY       = $01B1  ; store immediate keystroke from %A
GET_KEY         = $01BE  ; get immediate keystroke into %A
TX_CHARPUT      = $8C41  ; xlated display of %A on screen, normal text style
D_LT_STR        = $8C44  ; display length-byte normal text string
M_CHARPUT       = $8C47  ; display %A on screen, menu style
D_ZM_STR        = $8C4A  ; display zero-terminated string, meny style
D_LM_STR        = $8C4D  ; display length-byte string, menu style
GET_T_CUR       = $8C50  ; HL = absolute address of text cursor
SCROLL_UP       = $8C53  ; scroll text screen up
TR_CHARPUT      = $8C56  ; raw display of %A on screen, normal text style
CLEARLCD        = $8C59  ; clear LCD, but not text or graphics memory
D_HL_DECI       = $8C5C  ; disp. HL as 5-byte, right just., blank-pad, decimal
CLEARTEXT       = $8C5F  ; clear LCD and text memory (affected by 1, (IY+13))
D_ZT_STR        = $8C62  ; display zero-terminated normal text string
BUSY_OFF        = $8C65  ; turn off "busy" indicator
BUSY_ON         = $8C68  ; turn on "busy" indicator

;Page 4
;
FIND_PIXEL      = $8C6B  ; Find location in RAM for a pixel on the GFX screen

;Ŀ
; Rigel Routine Locations                                                   
;
INT_INSTALL     = $8C6E  ; Install Interrupt with (HL) == Address of Routine
INT_REMOVE      = $8C71  ; Remove Interrupt
VAR_SEARCH      = $8C06  ; Search for a variable in the VAT
;Ŀ
; Important RAM Locations                                                   
;
KEY_0           = $8000  ; translated scancode of last key, but 0 if gotten
KEY_1           = $8001  ; translated scancode of key down now
KEY_2           = $8002  ; same as 8001, but $FF if more than one key is down
KEY_STAT        = $8004  ; bit 2 set = key down now
LAST_KEY        = $8006  ; last key pressed
CONTRAST        = $8007  ; contrast
CURSOR_ROW      = $800C  ; text cursor row
CURSOR_COL      = $800D  ; text cursor column
CURSOR_LET      = $800E  ; letter under text cursor
BUSY_COUNTER    = $8080  ; counter for busy indicator
BUSY_BITMAP     = $8081  ; bitmap for busy indicator
CURR_INPUT      = $80C6  ; -> current home-screen input
BYTES_USED      = $80CC  ; # of used user memory (Add to 80C8 to find first 
                         ; byte of free memory)
TEXT_MEM        = $80DF  ; text memory
CURSOR_ROW2     = $800C  ; text cursor row
CURSOR_COL2     = $800D  ; text cursor column
CHECKSUM        = $81BE  ; memory checksum from 8BF7 to FA6F
CURSOR_X        = $8333  ; x value of cursor
CURSOR_Y        = $8334  ; y value of cursor
_IY_TABLE       = $8346  ; where IY usually points
GRAPH_MEM       = $8641  ; graphics memory
TEXT_MEM2       = $8A6B  ; secondary text memory
USER_MEM        = $8B1B  ; -> start of user memory
FIXED_POINT     = $8B3A  ; fixed-point decimal place (FFh for floating point)
VAT_END         = $8BEB  ; -> one byte before end of VAT (backwards)
VAT_START       = $FA6F  ; start of VAT
VIDEO_MEM       = $FC00  ; video memory
;Ŀ
; Keypad Scancodes                                                          
;
;                        Function                Character
K_NOKEY         = $00    ;No key
K_DOWN          = $01    ;Down
K_LEFT          = $02    ;Left
K_RIGHT         = $03    ;Right
K_UP            = $04    ;Up
K_ENTER         = $09    ;Enter
K_PLUS          = $0A    ;+                      X
K_MINUS         = $0B    ;-                      T
K_STAR          = $0C    ;*                      O
K_SLASH         = $0D    ;/                      J
K_RAISE         = $0E    ;^                      E
K_CLEAR         = $0F    ;Clear
K_SIGN          = $11    ;(-)                    Space
K_3             = $12    ;3                      W
K_6             = $13    ;6                      S
K_9             = $14    ;9                      N
K_RIGHTPAR      = $15    ;)                      I
K_TAN           = $16    ;Tan                    D
K_CUSTOM        = $17    ;Custom
K_DOT           = $19    ;.                      Z
K_2             = $1A    ;2                      V
K_5             = $1B    ;5                      R
K_8             = $1C    ;8                      M
K_LEFTPAR       = $1D    ;(                      H
K_COS           = $1E    ;Cos                    C
K_PRGM          = $1F    ;Prgm
K_DEL           = $20    ;Del
K_0             = $21    ;0                      Y
K_1             = $22    ;1                      U
K_4             = $23    ;4                      Q
K_7             = $24    ;7                      L
K_EE            = $25    ;EE                     G
K_SIN           = $26    ;Sin                    B
K_STAT          = $27    ;Stat
K_XVAR          = $28    ;x-Var                  x
K_ON            = $29    ;On
K_STO           = $2A    ;Sto                    =
K_COMMA         = $2B    ;,                      P
K_SQUARE        = $2C    ;x^2                    K
K_LN            = $2D    ;Ln                     F
K_LOG           = $2E    ;Log                    A
K_GRAPH         = $2F    ;Graph
K_ALPHA         = $30    ;Alpha
K_F5            = $31    ;F5
K_F4            = $32    ;F4
K_F3            = $33    ;F3
K_F2            = $34    ;F2
K_F1            = $35    ;F1
K_SECOND        = $36    ;2nd
K_EXIT          = $37    ;EXIT
K_MORE          = $38    ;MORE
